#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include "counter_c.c"

//------------------------------------------------------------
// Switching the optimizations off proved to be necessary for
// the /O1 and /O2 options to prevent the compiler from
// breaking something in the macro code.
//------------------------------------------------------------

#pragma optimize( "", off )

int main(void)
{

    double x1 = 123, x2;

    Sleep(4000);

    CTR_BEGIN( 1, 1000, HIGH_PRIORITY_CLASS );
    CTR_END( 1 )
    printf( "%d cycles\n", ctr_cycles );

    CTR_BEGIN( 2, 1000, HIGH_PRIORITY_CLASS );
    CTR_END( 2 )
    printf( "%d cycles\n", ctr_cycles );

    CTR_BEGIN( 3, 1000, HIGH_PRIORITY_CLASS );
        __asm
        {
            mul ecx
        }
    CTR_END( 3 )
    printf( "%d cycles\n", ctr_cycles );

    CTR_BEGIN( 4, 1000, HIGH_PRIORITY_CLASS );
        __asm
        {
            mov eax, 1
            mov ecx, 1
            xor edx, edx
            div ecx
        }
    CTR_END( 4 )
    printf( "%d cycles\n", ctr_cycles );

    CTR_BEGIN( 5, 1000, HIGH_PRIORITY_CLASS );
        x2 = sqrt( x1 );
    CTR_END( 5 )
    printf( "%d cycles\n\n", ctr_cycles );


    CTR_BEGIN( 11, 1000, HIGH_PRIORITY_CLASS );
    CTR_END( 11 )
    printf( "%d cycles\n", ctr_cycles );

    CTR_BEGIN( 12, 1000, HIGH_PRIORITY_CLASS );
    CTR_END( 12 )
    printf( "%d cycles\n", ctr_cycles );

    CTR_BEGIN( 13, 1000, HIGH_PRIORITY_CLASS );
        __asm
        {
            mul ecx
        }
    CTR_END( 13 )
    printf( "%d cycles\n", ctr_cycles );

    CTR_BEGIN( 14, 1000, HIGH_PRIORITY_CLASS );
        __asm
        {
            mov eax, 1
            mov ecx, 1
            xor edx, edx
            div ecx
        }
    CTR_END( 14 )
    printf( "%d cycles\n", ctr_cycles );

    CTR_BEGIN( 15, 1000, HIGH_PRIORITY_CLASS );
        x2 = sqrt( x1 );
    CTR_END( 15 )
    printf( "%d cycles\n\n", ctr_cycles );


    CTR_BEGIN( 21, 1000, HIGH_PRIORITY_CLASS );
    CTR_END( 21 )
    printf( "%d cycles\n", ctr_cycles );

    CTR_BEGIN( 22, 1000, HIGH_PRIORITY_CLASS );
    CTR_END( 22 )
    printf( "%d cycles\n", ctr_cycles );

    CTR_BEGIN( 23, 1000, HIGH_PRIORITY_CLASS );
        __asm
        {
            mul ecx
        }
    CTR_END( 23 )
    printf( "%d cycles\n", ctr_cycles );

    CTR_BEGIN( 24, 1000, HIGH_PRIORITY_CLASS );
        __asm
        {
            mov eax, 1
            mov ecx, 1
            xor edx, edx
            div ecx
        }
    CTR_END( 24 )
    printf( "%d cycles\n", ctr_cycles );

    CTR_BEGIN( 25, 1000, HIGH_PRIORITY_CLASS );
        x2 = sqrt( x1 );
    CTR_END( 25 )
    printf( "%d cycles\n\n", ctr_cycles );

    getch();
    return 0;
}

#pragma optimize( "", on )
